#include<conio>
#include<iostream>
#include<fstream>
#include<dos>
#include<io>
#include<stdio>
#include<stdlib>

int **lab, maxx = 25, maxy = 22;
int cursorx = 0, cursory = 0, key = 1000, extended = 0;
char* labfile = new(char[256]);

void outp(int x, int y)
   {
   gotoxy(3*x+2,y+2);
   switch(lab[x][y])
      {
      case'M': cout << " M "; break;
      case'X': cout << " X "; break;
      case' ': cout << "   "; break;
      case'': cout << ""; break;
      default: cout << "";
               lab[x][y]='';
               break;
      }
   }

void load()
   {
   FILE *labin = fopen(labfile, "r");
   if(labin != NULL)
      {
      char c; int x = 0, y = 0;
      for(;;)
         {
         c = fgetc(labin);
         if(feof(labin))
            goto eoff;
         switch(c)
            {
            case ' ' : lab[x][y] = ' ';
                       break;
            case 'M' : lab[x][y] = 'M';
                       break;
            case 'X' : lab[x][y] = 'X';
                       break;
            case '\n': x = -1;
                       if(++y > maxy)
                          goto eoff;
                       break;
            default  : lab[x][y] = '';
            } // switch(c)
         if(++x > maxx)
            {
            x = 0;
            if(++y > maxy)
               goto eoff;
            for(;;)
               {
               c = fgetc(labin);
               if(feof(labin))
                  goto eoff;
               if(c == '\n')
                  break;
               }
            }
         } // for(;;)
      eoff:
      fclose(labin);
      } // if(labin != NULL)
   }

void save()
   {
   _rtl_chmod(labfile, 1 , 0);
   ofstream outdat(labfile);
   for(int i = 0; i < 23; i++)
      {
      for(int j = 0; j < 26; j++)
         outdat << (char)(lab[j][i]);
      outdat << "\n";
      }
   outdat.close();
   _rtl_chmod(labfile, 1 , 0);
   }

void refresh()
   {
   clrscr();
   _setcursortype(_NOCURSOR);
   gotoxy(1,1);
   textcolor(0); textbackground(7);
   cprintf(" Labyrinth Editor 1.0    2004 by Viktor Engelmann    http://www.AlgorithMan.de ");
   textcolor(7); textbackground(0);

   for(int i = 0; i <= maxy; i++)
      for(int j = 0; j <= maxx; j++)
         outp(j,i);
   }

int main(int argc, char** args)
   {
   char* labbak = "new.lab";
   for(int i = 0; i < strlen(labbak); i++)
      labfile[i]=labbak[i];
   labfile[strlen(labbak)]='\0';

   textmode(BW80);
   _setcursortype(_NOCURSOR);

   lab = new(int*[maxx+1]);
   for(int i = 0; i <= maxx; i++)
      {
      lab[i] = new(int[maxy+1]);
      for(int j = 0; j <= maxy; j++)
         lab[i][j] = '';
      }
   gotoxy(2,2);
// ======================================================================== Argument Handling
   if(argc > 1)
      labfile = args[1];
   load();
   refresh();
// =========================================================================== Get User Input
   do {
      gotoxy(cursorx*3+2,cursory+2);
      cout << "[" << char(lab[cursorx][cursory]) << "]";
      key = getch();
      if(!key)
         extended = getch();
      int i, j;
      char* exec = "labscan -d 0 -m ";
      char* command;
      switch(key)
         {
         case  32: if(lab[cursorx][cursory] == '')
         /* SPACE */  lab[cursorx][cursory] = ' ';
	                else
   	      	       lab[cursorx][cursory] = '';
      	          break;
         case 88:
         case 120: lab[cursorx][cursory] = 'X';
         /* X */   outp(cursorx, cursory);
                   break;
         case 77:
         case 109: lab[cursorx][cursory] = 'M';
         /* M */   outp(cursorx, cursory);
                   break;
         case  14: gotoxy(2,2);
      /* Ctrl+N */ for(i = 0; i <= maxy; i++)
		                {for(j = 0; j <= maxx; j++)
                         {cout << "";
                         lab[j][i] = '';}
                      cout << "\n ";}
                   break;
         case 0: switch(extended)
            	     {
                    case  61: gotoxy(5,25);
                    /*F3*/    cout << "Save As > ";
                              cin >> labfile;
                              gotoxy(1,24); clreol();
                    case  60: save();
                    /*F2*/    refresh();
                              break;
                    case  62: gotoxy(5,25);
                    /*F4*/    cout << "Load File > ";
                              cin >> labfile;
                              gotoxy(1,24); clreol();
                              load();
                              refresh();
                              break;
                    case  63: save();
                    /*F5*/    j=strlen(exec);
                              command=new(char[j+strlen(labfile)+1]);
                              for(i=j; i >= 0; --i)
                                 command[i]=exec[i];
                              for(i = 0; labfile[i] != '\0'; ++i)
                                 command[j+i]=labfile[i];
                              command[j+strlen(labfile)]='\0';
                              system(command);
                              //cout << command;
                              delete[](command);
                              refresh();
                              break;
                    case  72: outp(cursorx, cursory);
                    /* UP */  if(cursory > 0) cursory--; else cursory = 22;
                              break;
                    case  80: outp(cursorx, cursory);
                    /*DOWN*/  if(cursory < 22) cursory++; else	cursory = 0;
                              break;
                    case  75: outp(cursorx, cursory);
                    /*LEFT*/  if(cursorx > 0) cursorx--;  else cursorx = 25;
                              break;
                    case  77: outp(cursorx, cursory);
                    /*RIGHT*/ if(cursorx < 25) cursorx++; else cursorx = 0;
                              break;
                    case  71: outp(cursorx, cursory);
                    /*HOME*/  cursorx = 0;
                              break;
                    case  79: outp(cursorx, cursory);
                    /*END*/   cursorx = maxx;
                              break;
                    case  73: outp(cursorx, cursory);
                    /*PGUP*/  cursory = 0;
                              break;
                    case  81: outp(cursorx, cursory);
                    /*PGDN*/  cursory = maxy;
                              break;
                    case  82: for(i = maxx; i > cursorx; i--)
                    /* ins */    {lab[i][cursory] = lab[i-1][cursory];
                                 outp(i,cursory);}
                              lab[cursorx][cursory] = '';
                              outp(cursorx,cursory);
                              break;
                    case 45: for(i=maxx; i > cursorx; i--)
                    /*alt+x*/   for(j=0; j < maxy; j++)
                                   {lab[i][j]=lab[i-1][j];
                                   outp(i,j);}
                             for(i=0;i < maxy; i++)
                                {lab[cursorx][i]='';
                                outp(cursorx,i);}
                             break;
                    case 21: for(i=maxy; i > cursory; i--)
                    /*alt+y*/   for(j=0; j < maxx; j++)
                                   {lab[j][i]=lab[j][i-1];
                                   outp(j,i);}
                             for(i=0; i < maxx; i++)
                                {lab[i][cursory]='';
                                outp(i,cursory);}
                             break;
                    } // switch(extended)
                 break;
         case 46: for(i = cursorx; i < maxx; i++)
         /* del */    {lab[i][cursory] = lab[i+1][cursory];
                      outp(i,cursory);}
                   lab[maxx][cursory] = '';
                   outp(maxx,cursory);
                   break;
         case 24: for(i = cursorx; i < maxx; i++)
         /*Strg+X*/  for(j=0; j<=maxy; j++)
                        {lab[i][j]=lab[i+1][j];
                        outp(i,j);}
                     for(i=0;i<=maxy;i++)
                        {lab[maxx][i]='';
                        outp(maxx,i);}
                     break;
         case 25: for(i = cursory; i < maxy; i++)
         /*strg+Y*/  for(j = 0; j <= maxx; j++)
                        {lab[j][i] = lab[j][i+1];
                        outp(j,i);}
                  for(i = 0; i <= maxx; i++)
                     {lab[i][maxy] = '';
                     outp(i,maxy);}
                  break;
         } // switch(key)
      } while(key != 27);
   clrscr();
   return(0);
   }
